
#include "clk.h"

/*
 * ʹHSEʱϵͳʱӵĲ
 * 1HSE ȴ HSE ȶ
 * 2 AHBAPB2APB1ԤƵ
 * 3PLLʱԴPLLıƵӣøƵҪ
 * 4PLLȴPLLȶ
 * 5PLLCKлΪϵͳʱSYSCLK
 * 6ȡʱл״̬λȷPLLCLKѡΪϵͳʱ
 */

/*  ϵͳʱ:SYSCLK, AHBʱ:HCLK, APB2ʱ:PCLK2, APB1ʱ:PCLK1
 * PCLK2 = HCLK = SYSCLK
 * PCLK1 = HCLK
 * ˵pllmulPLLıƵӣڵõʱǣRCC_PLLMul_x , x:[2,3,...16]
 * User_SetSysClock(RCC_PLLMul_9);  ϵͳʱΪ8MHZ * 9 = 72MHZ
 * HSEΪʱԴPLLƵΪϵͳʱӣͨ
 */

void HSE_SetSysClock(uint32_t pllmul)
{
    __IO uint32_t HSEStartUpStatus = 0;

  // RCCʼɸλ״̬
  RCC_DeInit();

  //ʹHSEⲿ
  RCC_HSEConfig(RCC_HSE_ON);

  // ȴ HSE ȶ
  HSEStartUpStatus = RCC_WaitForHSEStartUp();

    // ֻ HSE ȶִ֮
  if (HSEStartUpStatus == SUCCESS)
  {
//----------------------------------------------------------------------//
    // ǲFLASHõģFLASHĻע͵ҲûӰ
    // ʹFLASH Ԥȡ
    FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable);

    // SYSCLKʱıãͳһó2
    // ó2ʱSYSCLK48MҲԹó01ʱ
    // õSYSCLK˷ΧĻӲ󣬳
    // 00 < SYSCLK <= 24M
    // 124< SYSCLK <= 48M
    // 248< SYSCLK <= 72M
    FLASH_SetLatency(FLASH_Latency_2);
//----------------------------------------------------------------------//

    // AHBԤƵΪ1ƵHCLK = SYSCLK
    RCC_HCLKConfig(RCC_SYSCLK_Div1);

    // APB2ԤƵΪ1ƵPCLK2 = HCLK
    RCC_PCLK2Config(RCC_HCLK_Div1);

    // APB1ԤƵΪ1ƵPCLK1 = HCLK/2
    RCC_PCLK1Config(RCC_HCLK_Div2);

//-----------------øƵҪ-------------------//
    // PLLʱԴΪHSEPLLƵ
    // PLLCLK = 8MHz * pllmul
    RCC_PLLConfig(RCC_PLLSource_HSE_Div1, pllmul);
//------------------------------------------------------------------//

    // PLL
    RCC_PLLCmd(ENABLE);

    // ȴ PLLȶ
    while (RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET)
    {
    }

    // PLLȶ֮󣬰PLLʱлΪϵͳʱSYSCLK
    RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);

    // ȡʱл״̬λȷPLLCLKѡΪϵͳʱ
    while (RCC_GetSYSCLKSource() != 0x08)
    {
    }
  }
  else
  {
    // HSEʧܣôͻûӳĴ봦
    // HSEʧܻ߹ϵʱ򣬵ƬԶHSIΪϵͳʱӣHSIڲĸʱӣ8MHZ
    while (1)
    {
    }
  }
}


/*
 * ʹHSIʱϵͳʱӵĲ
 * 1HSI ȴ HSI ȶ
 * 2 AHBAPB2APB1ԤƵ
 * 3PLLʱԴPLLıƵӣøƵҪ
 * 4PLLȴPLLȶ
 * 5PLLCKлΪϵͳʱSYSCLK
 * 6ȡʱл״̬λȷPLLCLKѡΪϵͳʱ
 */

/*  ϵͳʱ:SYSCLK, AHBʱ:HCLK, APB2ʱ:HCLK2, APB1ʱ:PCLK1
 * PCLK2 = HCLK = SYSCLK
 * PCLK1 = HCLK
 * ˵pllmulPLLıƵӣڵõʱǣRCC_PLLMul_x , x:[2,3,...16]
 *
 * HSIΪʱԴPLLƵΪϵͳʱӣHSEϵʱʹõķ
 * HSIΪ¶ȵԭƯƣȶһ㲻HSIΪʱԴȲѵ
 * HSIҪΪPLLʱӵԴĻѡƵ߲ƵֱPLLоƬʹHSIʱ72MHzƵ
 * HSIΪPLLʱӣʾϵͳʱΪ 24MHz48MHz72MHz
 * HSI/2ΪPLLʱӣʾϵͳʱΪ 24MHz48MHz
 */
void HSI_SetSysClock(uint32_t pllmul)
{

#if (PLL_Source == HSI)
  EXTEN->EXTEN_CTR |= EXTEN_PLL_HSI_PRE;  //HSIʱΪPLLʱ
#endif

  __IO uint32_t HSIStartUpStatus = 0;

  // RCCʼɸλ״̬
  RCC_DeInit();

  //ʹHSI
  RCC_HSICmd(ENABLE);

  // ȴ HSI 
  HSIStartUpStatus = RCC->CTLR & RCC_HSIRDY;

  // ֻ HSIִ֮
  if (HSIStartUpStatus == RCC_HSIRDY)
  {
//----------------------------------------------------------------------//
    // ǲFLASHõģFLASHĻע͵ҲûӰ
    // ʹFLASH Ԥȡ
    FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable);

    // SYSCLKʱıãͳһó2
    // ó2ʱSYSCLK48MҲԹó01ʱ
    // õSYSCLK˷ΧĻӲ󣬳
    // 00 < SYSCLK <= 24M
    // 124< SYSCLK <= 48M
    // 248< SYSCLK <= 72M
    FLASH_SetLatency(FLASH_Latency_2);
//----------------------------------------------------------------------//

    // AHBԤƵΪ1ƵHCLK = SYSCLK
    RCC_HCLKConfig(RCC_SYSCLK_Div1);

    // APB2ԤƵΪ1ƵPCLK2 = HCLK
    RCC_PCLK2Config(RCC_HCLK_Div1);

    // APB1ԤƵΪ1ƵPCLK1 = HCLK/2
    RCC_PCLK1Config(RCC_HCLK_Div2);

//-----------------øƵҪ-------------------//
    // PLLʱԴΪHSIPLLƵ
    // PLLCLK = 8MHz * pllmul
    // PLLʱԴΪHSI/2PLLƵ
    // PLLCLK = 4MHz * pllmul
    RCC_PLLConfig(RCC_PLLSource_HSI_Div2, pllmul);
//------------------------------------------------------------------//

    // PLL
    RCC_PLLCmd(ENABLE);

    // ȴ PLLȶ
    while (RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET)
    {
    }

    // PLLȶ֮󣬰PLLʱлΪϵͳʱSYSCLK
    RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);

    // ȡʱл״̬λȷPLLCLKѡΪϵͳʱ
    while (RCC_GetSYSCLKSource() != 0x08)
    {
    }
  }
  else
  {
    // HSIʧܣôͻûӳĴ봦
    // HSEʧܻ߹ϵʱ򣬵ƬԶHSIΪϵͳʱӣHSIڲĸʱӣ8MHZ
    while (1)
    {
    }
  }
}


